/*
	  
	  http://jass.ucoz.net/
	     
*/

#include "version.h" //    
//   :
#include <jka/game/q_shared.h>
#include <jka/game/g_local.h>
#include <jassapi.h> //,  
#include <string>
#include <time.h>
#define strcasecmp stricmp 
pluginres_t* g_result = NULL;
//  
plugininfo_t g_plugininfo = {
	"Server time",					// 
	Plugin_Base_version,			//
	"Shows server time to chat when player sends a !svtime say command",				//
	Plugin_Base_Builder,			//
	"http://www.jass.ucoz.net/",	//
	1,								//    
	1,								//        
	1,								//        
	JASS_PIFV_MAJOR,				//  (  jassapi.h)
	JASS_PIFV_MINOR				
};
eng_syscall_t g_syscall = NULL;
mod_vmMain_t g_vmMain = NULL;
pluginfuncs_t* g_pluginfuncs = NULL;

bool isrequested = 0;
time_t rawtime;
struct tm *raw_tm;
int temp_prev = -1;
int frameshot=20;
int frames=0;

//  ,  
// pinfo -    g_plugininfo ( )
C_DLLEXPORT void JASS_Query(plugininfo_t** pinfo) {
	JASS_GIVE_PINFO();
}

// ,  
// ,    ,  
// engfunc -    syscall 
// modfunc -    vmMain 
// presult -      
// iscmd -  : 0 =    jass.ini, 1 =    "jass load"
C_DLLEXPORT int JASS_Attach(eng_syscall_t engfunc, mod_vmMain_t modfunc, pluginres_t* presult, pluginfuncs_t* pluginfuncs, int iscmd) {
	JASS_SAVE_VARS();

	g_syscall(G_CVAR_REGISTER,0,"svtime_format","^2Current server time is ^3%h:%m",0);
	g_syscall(G_CVAR_REGISTER,0,"svtime_hidecmd","0",0);
	iscmd = 0;
	return 1;
	//return 0; - 
}

//  ,  
// ,    ,  
// - iscmd  ; 0 =         "jass force_unload", 1 =   "jass unload"
C_DLLEXPORT void JASS_Detach(int iscmd) {
	iscmd = 0;
}

//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_SHUTDOWN,  
C_DLLEXPORT int JASS_vmMain(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {
	if (cmd == GAME_INIT){
		int x=JASS_GETINTCVAR("sv_fps");
		if (x>0){
			frameshot=x;
		}
	}

	if (cmd == GAME_CLIENT_COMMAND){
		int argc = g_syscall(G_ARGC);
		char command[16];
		g_syscall(G_ARGV, 0, command, sizeof(command));
		if (argc>1&&(!strcasecmp(command,"say")||!strcasecmp(command,"say_team"))){
			g_syscall(G_ARGV, 1, command, sizeof(command));
			if (!strcasecmp(command,"!svtime")){
				isrequested = 1;
				if (JASS_GETINTCVAR("svtime_hidecmd")){
					JASS_RET_SUPERCEDE(1);
				}
			}
		}
	}

	if (cmd==GAME_RUN_FRAME && !( !isrequested && (++frames%frameshot) )){
		time(&rawtime);
		raw_tm = localtime(&rawtime);
		if(((raw_tm->tm_min == 30 || raw_tm->tm_min == 0) && raw_tm->tm_min!=temp_prev) || isrequested ){
			//char format[256];
			char *format=(char *)JASS_GETSTRCVAR("svtime_format");
			char result[512];
			//strcpy(format,JASS_GETSTRCVAR("svtime_output"));
			int k=0;
			for(int i = 0; i < strlen(format)-1; ++i){
				if(format[i] == '%' && format[i+1] == 'h'){
					sprintf(result+k,"%02d",raw_tm->tm_hour);
					k+=2;
					++i;
					continue;
				}
				if(format[i] == '%' && format[i+1] == 'm'){
					sprintf(result+k,"%02d",raw_tm->tm_min);
					k+=2;
					++i;
					continue;
				}
				result[k] = format[k];
				++k;
			}
			result[k] = '\0';
			int maxclients = JASS_GETINTCVAR("sv_maxclients");
			for(int i=0;i<maxclients;++i){
				g_syscall(G_SEND_SERVER_COMMAND, i, JASS_VARARGS("chat \"%s^2\n\"", result));
			}


			//char *time_say_string = JASS_VARARGS((char*)JASS_GETSTRCVAR("svtime_output"),raw_tm->tm_hour,raw_tm->tm_min);
			//int maxclients = JASS_GETINTCVAR("sv_maxclients");
			//for(int i=0;i<maxclients;++i){
			//	g_syscall(G_SEND_SERVER_COMMAND, i, JASS_VARARGS("chat \"%s\n\"", time_say_string));
			//}
			temp_prev = raw_tm->tm_min;
			isrequested = 0;
		}
	}
	/*
	if (cmd == GAME_CLIENT_COMMAND) { //  (    g_public.h)
	//      g_syscall,
	//  g_syscall(G_PRINT, "Hi!\n");
	//      g_vmMain
	//   /     g_public.h
	} else if (cmd == GAME_SERVER_COMMAND){
	JASS_RET_SUPERCEDE(1); //  
	}
	*/
	//g_syscall(G_PRINT, JASS_VARARGS("vmMain(%s)\n", JASS_MODMSGNAME(cmd)));

	JASS_RET_IGNORED(1); //  
}

//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	/*
	if (cmd == G_PRINT) {
		JASS_RET_SUPERCEDE(1);
	}
	*/
	//g_syscall(G_PRINT, JASS_VARARGS("syscall(%s)\n", JASS_ENGMSGNAME(cmd)));

	JASS_RET_IGNORED(1);
}

//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_INIT,  
C_DLLEXPORT int JASS_vmMain_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {
	//g_syscall(G_PRINT, JASS_VARARGS("vmMain_Post(%s)\n", JASS_MODMSGNAME(cmd)));
	JASS_RET_IGNORED(1);
}

//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	//g_syscall(G_PRINT, JASS_VARARGS("syscall_Post(%s)\n", JASS_ENGMSGNAME(cmd)));
	JASS_RET_IGNORED(1);
}